#!/usr/bin/env python

# An example script using the rumba package

from rumba.model import *

# import testbed plugins
import rumba.testbeds.emulab as emulab
import rumba.testbeds.jfed as jfed
import rumba.testbeds.faketestbed as fake
import rumba.testbeds.qemu as qemu

# import prototype plugins
import rumba.prototypes.ouroboros as our
import rumba.prototypes.rlite as rl
import rumba.prototypes.irati as irati

import rumba.log as log

log.set_logging_level('DEBUG')


n1 = NormalDIF("n1")

n1.add_policy("rmt.pff", "lfa")
n1.add_policy("security-manager", "passwd")

e1 = ShimEthDIF("e1")

a = Node("a",
         difs = [n1, e1],
         dif_registrations = {n1 : [e1]})

b = Node("b",
         difs = [e1, n1],
         dif_registrations = {n1 : [e1]},
         client = True)

tb = jfed.Testbed(exp_name = "example1",
                  username = "user1",
                  cert_file = "/home/user1/cert.pem")

exp = rl.Experiment(tb, nodes = [a, b])

print(exp)

try:
    exp.swap_in()
    exp.bootstrap_prototype()
    c1 = Client("rinaperf", options ="-t perf -s 1000 -c 10000")
    s1 = Server("rinaperf", arrival_rate=2, mean_duration=5, options = "-l", nodes = [a], clients = [c1])
    sb = StoryBoard(exp, duration=3600, servers = [s1])
    sb.start()
finally:
    exp.swap_out()
